<template>
  <div class="full-page bg" element-loading-text="数据加载中..." element-loading-spinner="el-icon-loading"
  element-loading-background="rgba(255,255,255, 0.5)" v-loading.fullscreen.lock="markLoading">
    <div class="search-container">
      <el-form ref="form" :model="searchForm" label-width="auto">
        <el-row :gutter="20">
          <el-col :span="7">
            <el-form-item label="改革事项">
              <el-input v-model="searchForm.effectCardTopic" clearable placeholder="请输入改革事项"></el-input>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="5">
            <el-form-item label="所属领域">
              <dict-select dictCode="ggbb_ssly" :hasDefaultOption="true" clearable v-model="searchForm.effectField"
                style="width: 100%" @select="(val, obj) => hanldeCommonSelect(val, obj, 'serch')"
                placeholder="请选择所属领域" />
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="所属跑道">
              <el-select v-model="searchForm.effectRunway" style="width: 100%" clearable placeholder="请选择所属跑道">
                <el-option v-for="item in demandRunwaOoptionsSerch" :key="item.value" :label="item.name"
                  :value="item.value">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col> -->

          <el-col :span="7">
            <el-form-item label="专项小组">
              <dict-select dictCode="zxxz" :hasDefaultOption="true" clearable v-model="searchForm['group_Name_']"
                style="width: 100%" placeholder="请选择专项小组" />
            </el-form-item>
          </el-col>

          <el-col :span="7">
            <el-form-item label="审核状态">
              <el-select v-model="searchForm['status_']" placeholder="请选择" clearable :disabled="!switchStatus">
                <el-option v-for="item in statusOptions" :key="item.id" :label="item.name" :value="item.value">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="2">
            <el-button icon="el-icon-search" type="primary" class="btn btn-plus" @click="handleSearch">
              {{ this.$t('common.search') }}
            </el-button>
          </el-col>
        </el-row>
      </el-form>
    </div>
    <el-row :gutter="10" class="main-table-container flex">
      <el-col :span="24" class="table-container" ref="contentPanel" style="padding: 20px">
        <div style="margin-bottom: 10px" ref="btnPanel">
          <el-button type="danger" plain :class="[
        'btn',
        'btn-plus',
        switchStatus ? '' : 'btn-reviewed',
      ]" @click="handleSwitch(false)">
            待审核
          </el-button>
          <el-button slot="reference" type="success" plain :class="[
        'btn',
        'btn-delete',
        switchStatus ? 'btn-audited' : '',
      ]" @click="handleSwitch(true)">
            已审核
          </el-button>
        </div>
        <div :style="{ width: '100%', height: `${tableMaxHeight}` + 'px' }">
          <el-table stripe size="mini" v-loading="tableLoading" ref="multipleSelection" :data="tableData"
            :max-height="tableMaxHeight" :style="{
        width: '100%',
        height: `${tableMaxHeight}` + 'px',
      }">
            <el-table-column type="index" width="55" label="序号" align="center">
            </el-table-column>
            <el-table-column prop="effectCardTopic" show-overflow-tooltip min-width="280" align="center" label="改革事项">
            </el-table-column>
            <el-table-column prop="groupName" show-overflow-tooltip min-width="200" align="center" label="专项小组">
            </el-table-column>
            <!-- <el-table-column prop="effectField" show-overflow-tooltip min-width="100" align="center" label="所属领域">
              <template v-slot="{ row }">
                {{ getDictName('ggbb_ssly', row.effectField) }}
              </template>
</el-table-column>
<el-table-column prop="effectRunway" show-overflow-tooltip min-width="100" align="center" label="所属跑道">
  <template v-slot="{ row }">
                {{ getDictName('ggbb_sspd', row.effectRunway) }}
              </template>
</el-table-column> -->
            <el-table-column prop="operateDate" show-overflow-tooltip min-width="100" align="center" label="提交审核时间">
            </el-table-column>
            <el-table-column show-overflow-tooltip width="140" align="center" label="审核状态">
              <template v-slot="{ row }">
                <el-tag :type="getTagType(row.status)">
                  {{ getDictName('sjcxls_shzt', row.status) }}
                </el-tag>
              </template>
            </el-table-column>
            <el-table-column min-width="160" align="center" fixed="right" label="操作">
              <template v-slot="{ row }">
                <el-link v-if="row.status == 1" icon="el-icon-s-check" type="primary" :underline="false"
                  class="cloumn-btn" @click="handleAudit(row)">
                  审核
                </el-link>
                <el-link v-else icon="el-icon-view" type="primary" :underline="false" class="cloumn-btn"
                  @click="handleDetail(row)">
                  详情
                </el-link>
                <el-link v-if="row.status == 3 || row.status == 2 || (row.groupName === '其它' && row.status == 5)" icon="el-icon-refresh-left" type="danger"
                  :underline="false" class="cloumn-btn wait-updata-btn" @click="handleUpdateStatus(row, 1)">
                  撤回
                </el-link>
              </template>
            </el-table-column>
          </el-table>
        </div>
        <effectDialog ref="effectDialog" @refreshData="refreshData"></effectDialog>
        <pagination ref="paginationPanel" style="margin-top: 10px" :pageResult="pageResult"
          @size-change="handleSizeChange" @current-change="handleCurrentChange" />
      </el-col>
    </el-row>
  </div>
</template>

<script>
import pagination from '@/components/pagination'
import { TableMixin } from '@/mixins/tableMixin'
import req from '@/request.js'
import utils from '@/utils.js'
import effectDialog from './dialog/effectDialog.vue'
import apiLsit from '@/api/effect'
const portal = window.context.portal
export default {
  name: 'cityReformSchoolEntry',
  components: {
    pagination,
    effectDialog,
  },
  mixins: [TableMixin],
  data() {
    return {
      tableMaxHeight: 400,
      loading: false,
      tableLoading: false,
      tableData: [],
      multipleSelection: [],
      params: {
        pageBean: {
          page: 1,
          pageSize: 20,
          total: 0,
        },
        querys: [
          {
            group: 'main',
            operation: 'IN',
            property: 'r.status_',
            relation: 'AND',
            value: [1],
          },
          {
            group: 'main',
            operation: 'IN',
            property: 'r.effect_Form_',
            relation: 'AND',
            value: [1, 2],
          },
        ],
      },
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0,
      },
      searchForm: {}, // 顶部搜索对象
      deleteIds: '', // 是否选中列表解锁删除按钮
      isAppear: false,
      markLoading: false
    }
  },

  created() {
    this.loadData(this.params)
    this.setStatusOptions('sjcxls_shzt', 1)
  },
  methods: {
    getTagType(status) {
      return status < 1 ? 'info' : status == 7 ? 'success' : status % 2 === 0 ? 'danger' : ''
    },
    //获取数据
    loadData(params) {
      this.tableLoading = true
      apiLsit.getCItyTableData(false, 1, params, (res) => {
        this.tableLoading = false
        this.tableData = res.rows || []
        this.pageResult = {
          page: res.page,
          pageSize: res.pageSize,
          total: res.total,
        }
      })
    },

    refreshData() {
      this.loadData(this.params)
    },

    getDictName(code, value) {
      return utils.getDictName(code, value)
    },

    //添加
    handleAudit(row) {
      this.$refs.effectDialog.openDialog(row, '审核', '市级')
    },
    handleDetail(row) {
      this.$refs.effectDialog.openDialog(row, '详情', '市级')
    },
    // 撤回
    handleUpdateStatus(row, status) {
      this.$confirm(`确定撤回吗？`, this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'error',
      }).then(() => {
        this.markLoading = true
        let data = {
          effectId: row.id,
          id: row.effectivenessId,
          status,
          approvalResults: 2
        }
        apiLsit.updateSatusById(data, res => {
          if (res.state) {
            row.status = status
            this.$message.success('撤回成功')
            this.loadData(this.params)
          }
          this.markLoading = false
        })
      })
    },
    handleSwitch(bol) {
      this.switchStatus = bol
      if (!bol) {
        this.searchForm['status_'] = ''
      }
      this.params.querys[0].value = bol ? [2, 3, 4, 5, 6, 7] : [1]
      this.handleSearch()
    },
    // 顶部搜索
    handleSearch() {
      let data = JSON.parse(JSON.stringify(this.params))
      let obj = JSON.parse(JSON.stringify(this.searchForm))
      let querys = []
      for (let i in obj) {
        if (obj[i]) {
          if (i !== 'status_') {
            querys.push({
              group: 'main',
              operation: i == 'effectCardTopic' ? 'LIKE' : 'EQUAL',
              parentGroup: '',
              property: i,
              relation: 'AND',
              value: obj[i],
            })
          } else {
            data.querys[0].value = [obj[i]]
          }
        }
      }
      this.params.querys = [...data.querys,...querys]
      this.params.pageBean.page = 1
      this.loadData(this.params)
    },
    handleCurrentChange(page) {
      this.params.pageBean = { ...this.params.pageBean, page }
      this.loadData(this.params)
    },
    handleSizeChange(pageSize) {
      this.params.pageBean = { ...this.params.pageBean, pageSize }
      this.loadData(this.params)
    },
  },
}
</script>

<style lang="scss" scoped>
.common-tree-container {
  height: calc(100% - 70px);
  margin-top: 0.52083vw;
  padding: 1.04167vw 1.04167vw;
  background-color: #fff;
  position: relative;
  box-sizing: border-box;
  overflow-y: auto;
  border-radius: 20px;
  box-shadow: 0px 0px 0.625vw 0 rgba(92, 102, 83, 0.2);
}

.container-head {
  display: flex;
  align-items: center;

  i {
    font-size: 16px;
    margin-left: 5px;
    font-weight: 600;
    cursor: pointer;
  }
}

.move-tree /deep/ .el-tree {
  height: 90%;
  overflow-y: auto;
  border: none;
}

.cloumn-btn {
  border: 1px solid #2761ff;
  padding: 3px 10px;
  border-radius: 5px;

  &:nth-child(1) {
    margin-right: 5px;
  }

  &:nth-child(1):hover {
    background-color: #2761ff;
    color: #fff;
  }

  &:nth-child(2):hover {
    background-color: #2761ff;
    color: #fff;
  }

  // &:nth-child(2):hover {
  //   background-color: #f56c6c;
  //   color: #fff;
  //   border-color: #f56c6c;
  // }
  /deep/ i,
  span {
    font-size: 16px;
  }
}

.wait-updata-btn {
  border: 1px solid #f56c6c;
  margin-left: 5px;
  padding: 3px 10px;
  border-radius: 5px;

  &:hover {
    background-color: #f56c6c !important;
    color: #fff !important;
    border-color: #f56c6c !important;
  }
}

/deep/ .el-tree-node__content {
  padding: 5px 0;
}

/deep/ .el-divider--horizontal {
  margin: 0;
}

.h2-title {
  font-size: 18px;
  margin: 0;
  padding: 0;
}

.detils-item {
  box-sizing: border-box;
  padding: 10px;
  position: relative;
  cursor: pointer;
  border: 1px dashed #fff;

  // &:hover {
  //   border: 1px dashed #2761ff;
  //   .add-del-btn {
  //     display: block;
  //   }
  // }
  .add-del-btn {
    position: absolute;
    display: none;
    right: 10px;
    top: 10px;
    z-index: 9999;
  }
}

.add-btn {
  font-weight: bold;
  cursor: pointer;
  color: #2761ff;
  font-size: 16px;
}

.del-btn {
  font-size: 16px;
  font-weight: bold;
  margin-left: 10px;
  color: #f56c6c;
  cursor: pointer;
}

.upload_file {
  opacity: 1;
  pointer-events: auto;
  transition: opacity 0.3s;
}

.upload_file_none {
  opacity: 0;
  pointer-events: none;
  transition: opacity 0.3s;
}
</style>